package sexpression

import sexpression.Symbol.Companion.T

@DisplayName("nil")
object Nil : Cons(T, T) {

    override var first: SExpression = this
        set(_) {}

    override var rest: SExpression = this
        set(_) {}

    override val isNull: Boolean
        get() = true

    override val isAtom: Boolean
        get() = true

    override val isCons: Boolean
        get() = false

    override val isSymbol: Boolean
        get() = true

    override fun toString() = "NIL"
}
