package recursion

import org.junit.jupiter.api.Assertions.assertThrows
import org.junit.jupiter.api.Test
import recursion.TailCalls.done

class TailCallTest {

    @Test
    fun `tailCall does not support result`() {
        val tailCall = TailCall<Any> { null }

        assertThrows(UnsupportedOperationException::class.java) { tailCall.result() }
    }

    @Test
    fun `done does not support apply`() {
        assertThrows(UnsupportedOperationException::class.java) { done<Any>(null).apply() }
    }
}
